import sys
import time
import random

k = int(sys.argv[2])
n = int(open(sys.argv[1]+'.n').readline())
m = int(open(sys.argv[1]+'.m').readline())

start = time.time()
load = []
for i in xrange(k):
    load.append(0)
machovert = []
for i in xrange(n):
    machovert.append([])
vertpart = []
for l in open(sys.argv[1] + '.vertex.' + str(k)):
    vertpart.append(int(l))

for l in open(sys.argv[1]):
    if l[0] != '#':
        s = l.split('\t')
        (a,b) = (int(s[0])-1,int(s[1])-1)
        if int(random.random()*2) == 1:
            part = vertpart[a]
        else:
            part = vertpart[b]
        load[part] += 1
        if part not in machovert[a]:
            machovert[a].append(part)
        if part not in machovert[b]:
            machovert[b].append(part)

runtime = time.time() - start
maxload = max([x*float(k)/m for x in load])
mirrors = sum([max(0,len(x)-1) for x in machovert])

print >> open(sys.argv[1]+'.vertoedge.'+str(k)+'.runtime','a+'), runtime
print >> open(sys.argv[1]+'.vertoedge.'+str(k)+'.maxload','a+'), maxload
print >> open(sys.argv[1]+'.vertoedge.'+str(k)+'.cost','a+'), mirrors


